#ifndef __XLPDEMO_H
#define __XLPDEMO_H
#include "system.h"



//   
//#define USE_PWRCTL
//  
//#define OPTIMIZE_A            //   
//#define OPTIMIZE_B            //   ADC, T2, I2C, UART,    

#define OSC_8		//    8 
//#define OSC1		//    1 

//  
#define USE_CAPTOUCH

//   
#define DEFAULT_MODE    LP_IDLE

#ifdef USE_CAPTOUCH
	#define DEFAULT_SENSOR  MODE_CAP
#else
	#define DEFAULT_SENSOR  MODE_TEMP
#endif

//   
#define USE_RTCC_ALARM

#define ALARM_PERIOD    TEN_SECOND   //   RTCC-  0.1 
#define ONE_SECOND      10
#define TEN_SECOND      100


#ifdef OSC_8
	#define OSC_MODE MHz_8
#else
	#define OSC_MODE MHz_1
#endif


//   UART  
#define DEFAULT_TX      TRUE

//   
#define USE_BUTTON_HOLD
//       
#define TEMP_WAIT       1   //1 
#define EEPROM_WAIT     3   //3 
#define UART_WAIT       1   //1 
#define POT_WAIT        1   //1 
          
//  UART
//#define BAUDRATE            9600UL
//#define BAUDRATE            1000000UL
#define BAUDRATE 	125000UL
#define BRGH_VAL            1
#define INVERT_UART         //  


//  

#define GetSystemClock()        8000000UL
#define GetPeripheralClock()    (GetSystemClock()/2)
#define GetInstructionClock()   (GetSystemClock()/2)
#define FCY                      GetInstructionClock()



//   
typedef enum
{
    LP_IDLE,
    LP_SLEEP,
    LP_DPSLP,
} LP_MODES;

typedef enum
{
	MHz_8,
	MHz_1,
} OSC_MODES;

//      
typedef union _TASK_VAL
{
    BYTE Val;
    struct
    {
        unsigned char mode:2;
        unsigned char sample:1;
        unsigned char transmit:1;
        unsigned char store:1;
        unsigned char button:1;
        unsigned char cap:1;
        unsigned char alarm:1;
    } bits;
} DEMO_TASKS;


void InitIO(void);
void InitSystem(void);
void HandleReset(void);

void IdleUs(int timeUs);
void IdleMs(int timeMs);


extern WORD eeAddress;	//   EEPROM
extern WORD potVal;		//     ( )
extern WORD tempVal;	//    0,1
extern WORD vddVal;		//     
extern WORD potVal_prev;		//     ( )
extern WORD tempVal_prev;	//    0,1
extern WORD vddVal_prev;		//     
extern WORD pressedCT1;	//     1 (1)
extern WORD pressedCT2;	//   2
extern WORD pressedCT3;	//   3
extern LP_MODES lpMode;	//   
extern DEMO_TASKS tasks;//  

#endif
