#ifndef _EEPROM_H
#define _EEPROM_H

#include "system.h"

//  I2C
#define I2C_CLOCK_FREQ      400000UL
#define I2CBRG_VAL          ((FCY/I2C_CLOCK_FREQ) - (FCY/ 10000000)) - 1
#define I2C_WRITE           0x00
#define I2C_READ            0x01

//  EEPROM
#define EEPROM_SIZE         32768   //  
#define EEPROM_ADDRESS      0xA0    // 
#define EEPROM_WRITE_WAIT   5       //    EEPROM  
#define EEPROM_ACK_WAIT     1000    //     10




void InitI2C(void);
void CloseI2C(void);
int I2CWait(void);
void T2IntOn(void);
void T2IntOff(void);


BYTE writePacket(WORD addr, BYTE* packet, BYTE numBytes);
BYTE readPacket(WORD addr,BYTE *packet, BYTE numBytes);
BYTE writeWait();
void StoreAddress(void);
void GetAddress(void);
void GetTimestamp(WORD addr);
void StoreData(WORD addr,WORD data, BYTE type);
void StoreSensorData(void);
void TransmitEEPROM(WORD addrMin,WORD addrMax);


#endif
