#ifndef _SENSORS_H
#define _SENSORS_H

#include "system.h"

//  
#define TEMP_TAD        31          //TAD
#define POT_TAD         31
#define VBG_TAD         31
#define VBG_VAL         1210UL*1024UL //VBG = 1.21V, VBG_VAL = 1210 mV * 1024 
#define VBG_CHANNEL     15
#define VBG_AN          AD1PCFGbits.PCFG15

//   
#define MCP9700         0
#define DIODE           1
#define TEMP_SENSOR     MCP9700


//: T = (V - V0)/TC
#define MCP_TC          10      //MCP9700   TC = 10mV/*C
#define MCP_V0          5000    //500  (10   0.1*C)
#define DIODE_TC        28      //1N4148   TC=-2.8mV/*C
#define DIODE_V0        39000   //390mV
                                

// 
typedef enum
{
    MODE_TEMP,
    MODE_POT,
#ifdef USE_CAPTOUCH
    MODE_CAP,
#endif
    MODE_ALL
} SENSOR_MODES;

//  
typedef enum
{
    CT1_DATA=1,
    CT2_DATA=2,
    CT3_DATA=3,
    N0_CT_PRESSED=4,
    POT_DATA=5,
    VDD_DATA=6,
    TEMP_DATA=7
} SENSOR_TYPES;


void InitADC(void);
WORD GetADCChannel(BYTE channel,BYTE timeTAD);

void SampleSensors(void);
void GetVddVal(void);
void GetTempVal(void);
void GetPOTVal(void);
void GetCapVal(void);


#endif
