#include "system.h"

/****************************************************************************
  :
    void TransmitData(void)

        
*****************************************************************************/
void TransmitData(void)
{
    //   ,  
    #ifdef USE_PWRCTL
    if(PWRCTL_PORT)
    {
        mPWR_ON();
        IdleMs(EEPROM_WAIT);	// 
    }
    #endif

    InitI2C();      // I2C   EEPROM
    _UxMD = 0;      //  UART
    UARTInit();

    switch(tasks.bits.mode)      //    
    {
        case MODE_TEMP:			//   
            switch(lpMode)  //    
    		{
        		case LP_SLEEP:
            		UARTPrintString("Current LPMODE: Sleep\r\n");
            		break;

        		case LP_DPSLP:
            		UARTPrintString("Current LPMODE: DeepSleep\r\n");
            		break;

        		case LP_IDLE:
        		    UARTPrintString("Current LPMODE: Idle\r\n");
 		            break;

		        default:
 	    		    break;
		    }
            UARTPrintString("Current Sensor: Temperature\r\n");
            TransmitDataType(eeAddress - 0x10,TEMP_DATA);
            break;

        case MODE_POT:			//   
            switch(lpMode)  //    
    		{
        		case LP_SLEEP:
            		UARTPrintString("Current LPMODE: Sleep\r\n");
            		break;

        		case LP_DPSLP:
            		UARTPrintString("Current LPMODE: DeepSleep\r\n");
            		break;

        		case LP_IDLE:
        		    UARTPrintString("Current LPMODE: Idle\r\n");
 		            break;

		        default:
 	    		    break;
		    }
            UARTPrintString("Current Sensor: POT Voltage\r\n");
            TransmitDataType(eeAddress - 0x20,VDD_DATA);
            TransmitDataType(eeAddress - 0x10,POT_DATA);
            break;

        #ifdef USE_CAPTOUCH
        case MODE_CAP:			//   
        	if ((pressedCT1) || (pressedCT2) || (pressedCT3)){
	            switch(lpMode)  //    
    			{
        			case LP_SLEEP:
            			UARTPrintString("Current LPMODE: Sleep\r\n");
            			break;

	        		case LP_DPSLP:
    	        		UARTPrintString("Current LPMODE: DeepSleep\r\n");
        	    		break;

        			case LP_IDLE:
        			    UARTPrintString("Current LPMODE: Idle\r\n");
 		            	break;

		        	default:
 	    		    	break;
		    	}      
            UARTPrintString("Current Sensor: CAP touch button\r\n");
            #ifndef CT2_IGNORE
            TransmitDataType(eeAddress - 0x30,CT1_DATA);
            TransmitDataType(eeAddress - 0x20,CT2_DATA);
            TransmitDataType(eeAddress - 0x10,CT3_DATA); 
            #else
            TransmitDataType(eeAddress - 0x20,CT1_DATA);
            TransmitDataType(eeAddress - 0x10,CT3_DATA); 
            #endif
         	}   
            break;
        #endif

        case MODE_ALL:			//   
        	if ((pressedCT1) || (pressedCT2) || (pressedCT3) || ((potVal_prev ^ potVal) & 0xFFF0) || ((vddVal_prev ^ vddVal) & 0xF000) || ((tempVal_prev ^ tempVal) & 0xFFF0)){
	        	switch(lpMode)  //    
    			{
        			case LP_SLEEP:
            			UARTPrintString("Current LPMODE: Sleep\r\n");
            			break;

	        		case LP_DPSLP:
    	        		UARTPrintString("Current LPMODE: DeepSleep\r\n");
        	    		break;

        			case LP_IDLE:
        			    UARTPrintString("Current LPMODE: Idle\r\n");
 		            	break;

		        	default:
 	    		    	break;
		    	} 
	        	potVal_prev = potVal;
	        	tempVal_prev = tempVal;
	        	vddVal_prev = vddVal;
             #ifdef USE_CAPTOUCH
             UARTPrintString("Current Sensor: Temperature, VDD, POT Voltage and CAP touch buttons\r\n");
    
             #ifndef CT2_IGNORE
                TransmitDataType(eeAddress - 0x60,TEMP_DATA);
                TransmitDataType(eeAddress - 0x50,VDD_DATA);
                TransmitDataType(eeAddress - 0x40,POT_DATA);
                TransmitDataType(eeAddress - 0x30,CT1_DATA);
                TransmitDataType(eeAddress - 0x20,CT2_DATA);
                TransmitDataType(eeAddress - 0x10,CT3_DATA);
            #else
                TransmitDataType(eeAddress - 0x50,TEMP_DATA);
                TransmitDataType(eeAddress - 0x40,VDD_DATA);
                TransmitDataType(eeAddress - 0x30,POT_DATA);
                TransmitDataType(eeAddress - 0x20,CT1_DATA);
                TransmitDataType(eeAddress - 0x10,CT3_DATA);
            #endif

           	#else
            
            	UARTPrintString("Current Sensor: Temperature, VDD, and POT Voltage\r\n");
        	    TransmitDataType(eeAddress - 0x30,TEMP_DATA);
    	        TransmitDataType(eeAddress - 0x20,VDD_DATA);
	            TransmitDataType(eeAddress - 0x10,POT_DATA);
            #endif
         	}   
            break;

        default:
            break;
    }
    /*		UARTPrintString("SW3 - turn on/off transmit\r\n");
			UARTPrintString("SW2 - make measurement\r\n");
			UARTPrintString("SW3 hold 2 sec - change low power mode\r\n");
			UARTPrintString("SW2 hold 2 sec - change sensors\r\n");
    		UARTPrintString("\r\n");
	*/
    CloseI2C();         // I2C
    #ifdef USE_PWRCTL	//   , 
    mPWR_OFF();
    #endif
    _UxMD = 1;			//  UART

}//end TransmitData()


/****************************************************************************
  :
    void TransmitSampleModeChange(void)

     
  ***************************************************************************/
void TransmitSampleModeChange(void)
{
    #ifdef USE_PWRCTL		//    
    	mPWR_ON();			// 
    	IdleMs(UART_WAIT);	// 
    #endif

  
    switch(tasks.bits.mode)	//   
    {
        case MODE_TEMP:		//  
            UARTPrintString("Changing sensor to Temperature   \r\n");
            break;

        case MODE_POT:		// 
            UARTPrintString("Changing sensor to POT Voltage   \r\n");
            break;

        #ifdef USE_CAPTOUCH
        case MODE_CAP:		//  
            UARTPrintString("Changing sensor to CAP touch button   \r\n");
            break;
        #endif

        case MODE_ALL:		//  
            #ifdef USE_CAPTOUCH
            UARTPrintString("Changing sensor to Temperature, VDD, POT Voltage and CAP touch button   \r\n");
            #else
            UARTPrintString("Changing sensor to Temperature, VDD, and POT Voltage\r\n");
            #endif
            break;

        default:
            break;
    }

    #ifdef USE_PWRCTL	//   
    mPWR_OFF();  		// 
    #endif
}

/****************************************************************************
  :
    void TransmitLPModeChange(void)

          
  ***************************************************************************/
void TransmitLPModeChange(void)
{
    #ifdef USE_PWRCTL		//   
    	mPWR_ON();			// 
    	IdleMs(UART_WAIT);
    #endif

    switch(lpMode)
    {
        case LP_SLEEP:		
            UARTPrintString("Changing low power mode to Sleep.\r\n");
            break;

        case LP_DPSLP:
            UARTPrintString("Changing low power mode to Deep Sleep.\r\n");
            break;

        case LP_IDLE:
            UARTPrintString("Changing low power mode to Idle.\r\n");
            break;

        default:
            break;
    }

    #ifdef USE_PWRCTL		//   
    	mPWR_OFF();  		// 
    #endif
}//end TransmitLPModeChange



/****************************************************************************
  :
    void TransmitDataType(WORD addr, SENSOR_MODES dataType)

      
  ***************************************************************************/
void TransmitDataType(WORD addr, SENSOR_MODES dataType)
{

    WORD temp;

     UARTPrintString("Current Data...");	

    UARTPrintString("Addr: 0x");
    UARTPutHexWord(addr);

    UARTPutChar(' ');
    UARTPutHex(rtcc.byte.mon);         // 
    UARTPutChar('/');
    UARTPutHex(rtcc.byte.mday);        // 
    UARTPrintString("/20");
    UARTPutHex(rtcc.byte.year);        // 
    UARTPutChar(' ');
    UARTPutHex(rtcc.byte.wday);        //  
    UARTPutChar(' ');
    UARTPutHex(rtcc.byte.hour);        // 
    UARTPutChar(':');
    UARTPutHex(rtcc.byte.min);         // 
    UARTPutChar(':');
    UARTPutHex(rtcc.byte.sec);         // 
    UARTPutChar(' ');

    
    switch(dataType)
    {
        case POT_DATA:
            UARTPrintString("POT Voltage: ");

            temp = potVal/1000;
            UARTPutChar(temp%10 + '0');

            UARTPutChar('.');

            temp = potVal/100;
            UARTPutChar(temp%10 + '0');

            temp = potVal/10;
            UARTPutChar(temp%10 + '0');

            temp = potVal;
            UARTPutChar(temp%10 + '0');
            UARTPutChar('V');
            break;
        case VDD_DATA:
            UARTPrintString("VDD Voltage: ");

            temp = vddVal/1000;
            UARTPutChar(temp%10 + '0');

            UARTPutChar('.');

            temp = vddVal/100;
            UARTPutChar(temp%10 + '0');

            temp = vddVal/10;
            UARTPutChar(temp%10 + '0');

            temp = vddVal;
            UARTPutChar(temp%10 + '0');
            UARTPutChar('V');
            break;
        case TEMP_DATA:
            UARTPrintString("Temp: ");

            temp = tempVal/100;
            UARTPutChar(temp%10 + '0');

            temp = tempVal/10;
            UARTPutChar(temp%10 + '0');

            UARTPutChar('.');

            temp = tempVal;
            UARTPutChar(temp%10 + '0');

            UARTPutChar('C');

            break;
        case CT1_DATA:
            UARTPrintString("Touch: ");

            if(pressedCT1)
                UARTPrintString("Cap touch button 1 pressed ");
            else
                UARTPrintString("Cap touch button 1 unpressed ");
            break;

        case CT3_DATA:
            UARTPrintString("Touch: ");

            if(pressedCT3)
                UARTPrintString("Cap touch button 3 pressed ");
            else
                UARTPrintString("Cap touch button 3 unpressed ");
            break;

        case CT2_DATA:
            UARTPrintString("Touch: ");

            if(pressedCT2)
                UARTPrintString("Cap touch button 2 pressed ");
            else
                UARTPrintString("Cap touch button 2 unpressed ");
            break;

        default:
            UARTPrintString("Error: Unknown Data.");
            break;
    }
    UARTPutChar('\r');
    UARTPutChar('\n');

}//end TransmitEEPROM(..)
